My code:
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
public class Solution {
public List<List<Integer>> permuteUnique(int[] nums) {
if (nums == null || nums.length == 0)
return null;
ArrayList<List<Integer>> result = new ArrayList<List<Integer>>();
ArrayList<Integer> permutations = new ArrayList<Integer>();
boolean[] isVisited = new boolean[nums.length];
Arrays.sort(nums);
getPemutations(nums, isVisited, result, permutations);
return result;
}
private void getPemutations(int[] nums, boolean[] isVisited,
ArrayList<List<Integer>> result, ArrayList<Integer> permutations) {
if (permutations.size() == nums.length)
result.add(new ArrayList<Integer>(permutations));
else {
for (int i = 0; i < nums.length; i++) {
if (isVisited[i])
continue;
else if (i > 0 && nums[i] == nums[i - 1] && !isVisited[i - 1])
continue;
permutations.add(nums[i]);
isVisited[i] = true;
getPemutations(nums, isVisited, result, permutations);
isVisited[i] = false;
permutations.remove(permutations.size() - 1);
}
}
}
}
My test result:
和之前的 permutations 相比,多了重复。那么怎么解决这个重复问题呢?
比如, 1,1,2
一开始进入,
1,1,2
1,2,1
会出现这些情况,然后逐步退栈,直到ArrayList<Integer> permutations 空了。
然后访问, nums[1] -> 1
但其实,这个情况和之前 nums[0] -> 1 的情况一模一样,完全没必要再走一遍,还会多出重复的结果。那么,怎么解决呢?
我的打算是,每一层递归,建立一个哈希表。不需要作为参数传入,就保留在每一层。
然后,遍历一个数,就存进去,并且在遍历的时候判断下,该数是否已经存在于哈希表了。如果已经存在了,说明之前,重点, 之前 已经遍历过了该数。就不需要再遍历一次了。
但是无疑开销是巨大的,需要在每一层都申请哈希表,太浪费空间了。
于是上网查了,发现一种更简洁的做法,我也知道一定会有这么简洁的做法的。
提前先将nums数组排下序,然后重复的数组就会靠在一块儿了。
比如,1,1,2
那么,当我访问第二个1时,可能会有两种情况。
第一种情况,目前我位于第二层递归,前面已经有了一个1进入了permutations,所以我应该处理这个1.
第二种情况,目前我位于第一层递归,目前permutations是空的。但因为我之前的1已经完完整整处理过了一次类似的过程, 所以这个1就可以直接跳过了。
那么怎么区分这两种情况呢?
看,isVisited[i - 1] 是否为真。
如果为真,说明前面的1已经被访问过了,那么当前就在第二层递归。处理。
如果为假,如果前面的1未被访问,说明之前已经处理过一轮了,这一轮不需要再处理了。
那么,直接 continue;
然后就可以解决重复的问题了。
推荐一个博客,讲的比我清楚。
http://bangbingsyb.blogspot.com/2014/11/leetcode-permutations-i-ii.html
**
总结: backtracing, 如何解决递归中的重复数字问题。
**
Anyway, Good luck, Richardo!
My code:
public class Solution {
public List<List<Integer>> permuteUnique(int[] nums) {
ArrayList<List<Integer>> ret = new ArrayList<List<Integer>>();
if (nums == null || nums.length == 0)
return ret;
Arrays.sort(nums);
ArrayList<Integer> group = new ArrayList<Integer>();
boolean[] isVisited = new boolean[nums.length];
helper(nums.length, nums, isVisited, group, ret);
return ret;
}
private void helper(int k, int[] nums, boolean[] isVisited,
ArrayList<Integer> group, ArrayList<List<Integer>> ret) {
if (k <= 0) {
ret.add(new ArrayList<Integer>(group));
return;
}
else {
for (int i = 0; i < nums.length; i++) {
if (isVisited[i])
continue;
else if (i > 0 && nums[i] == nums[i - 1] && isVisited[i - 1]) {
continue;
}
else {
group.add(nums[i]);
isVisited[i] = true;
helper(k - 1, nums, isVisited, group, ret);
isVisited[i] = false;
group.remove(group.size() - 1);
}
}
}
}
}
这次写的,没能处理的很好。在于,重复元素。
我的做法是,当前后相等时,把前个元素布尔位置为false。
然后以后dfs的时候,即使碰到他,也不会加进group,从而避免重复情况。
但是,其实可以直接把这种情况整个忽略了。
因为这和之前,前个元素作为开头所产生的permutation完全相同,不需要再次dfs了。
所以,改了之后,速度提升了许多。
Anyway, Good luck, Richardo!